use anyhow::bail;
use bytes::{Buf, BytesMut};
use prost::Message;
use tokio_util::codec::Decoder;
use crate::proto::Version;

pub enum MumbleMessages {

}

pub struct MumbleCodec {

}

impl MumbleCodec {
    pub fn new() -> Self {
        Self {}
    }
}

impl Decoder for MumbleCodec {
    type Item = ();
    type Error = anyhow::Error;

    fn decode(&mut self, src: &mut BytesMut) -> Result<Option<Self::Item>, Self::Error> {
        if src.len() < 6 {
            return Ok(None);
        }

        let message_type = u16::from_be_bytes(src[0..2].try_into()?) as usize;
        let message_length = u32::from_be_bytes(src[2..6].try_into()?) as usize;
        let message_data = &src[6..message_length];

        match message_type {
            0 => {
                //TODO: Version
                let version = Version::decode(message_data);
                println!("{version:?}");
                Ok(Some(()))
            }
            _ => {
                eprintln!("Unknown message type {:?}", message_type);
                Ok(None)
            }
        }
    }
}
